"""
Name: AF_UCS_Enviroment.py
Authors: Ryan Urbanowicz - written at Dartmouth College, Hanover, NH, USA
Contact: ryan.j.urbanowicz@darmouth.edu
Created: Feb. 12, 2010
---------------------------------------------------------------------------------------------------------------------------------------------------------
AF_UCS Version 1.0: An learning classifier system algorithm implemented with our new attribute tracking and feedback strategy for modeling epistasis and heterogeneity 
data mining and classification tasks.
Copyright (C) 2013 Ryan Urbanowicz 
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABLILITY 
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, 
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
---------------------------------------------------------------------------------------------------------------------------------------------------------
"""

#!/usr/bin/env python
class Environment:
    
    def resetDataCount(self):
        """ Resets the iteration count through the current data set. """
        raise Exception("Method 'resetDataCount' must be implemented")
        
        
    def resetState(self, isTrain): 
        """  Changes the state to the next sample input.  Once all of the data has been explored, the order is shuffled and it is explored again. """
        raise Exception("Method 'resetState' must be implemented")
                
                
    def getTrainState(self):
        """ Returns the current training state (set of attributes). """
        raise Exception("Method 'getTrainState' must be implemented")


    def getTestState(self):
        """ Returns the current training state (set of attributes). """
        raise Exceptions("Method 'getTestState' must be implemented")
    
    
    def getNumClasses(self):
        """ Returns the number of possible classes. """
        raise Exceptions("Method 'getNumClasses' must be implemented")


    def getNumTrainSamples(self):
        """ Returns the number of samples in the data set being examined. """        
        raise Exceptions("Method 'getNumTrainSamples' must be implemented")
    
    
    def getNumTestSamples(self):
        """ Returns the number of samples in the data set being examined. """        
        raise Exceptions("Method 'getNumTestSamples' must be implemented")
    
    
    def getHeaderList(self):
        """ Returns the file header text as a list of elements. """
        raise Exceptions("Method 'getHeaderList' must be implemented")
    
    
    def getAttributeCombos(self):
        """ Returns the number of possible attribute encodings.  Very specific to this type of environment. """
        raise Exceptions("Method 'getAttributeCombos' must be implemented")
    
    
    def getNumAttributes(self):
        """ Returns the number of attributes in the data set. """
        raise Exceptions("Method 'getNumAttributes' must be implemented")
